/*
commands
Left mouse button = reverse image 
center mouse button = save a .svg image (will save as test.svg unless key (S) is used first 
right mouse button = change stipple particle
+ and - increase and decrease spacing of stipple particles
L = selects an image to load
S = selects a save file to use (use before using center mouse button)
D = display the image in the background
*/

import processing.svg.*;

float sizes;
 
int x, y;
int save = 0;
int start = 1;
int stipple = 0;
int spacing = 8;
int display = 0;
int reverse = 0;
int counter = 0;

String saver = "test"; //default save file name .svg added in program
String loaded = "troy.jpg"; //default image (my 3rd son)

PImage original_img;
PGraphics stippledraw;

void setup() {
  size(605, 605, P2D); 
  restart();
}

void draw(){
  for (x = 0 +(spacing/2); x < height - (spacing/2); x = x + spacing) {
    for (y = 0 +(spacing/2); y < width - (spacing/2); y = y + spacing) {
      color pix = original_img.get(x, y);
      sizes = map(brightness(pix), 255, 0, 0, 8);
      strokeWeight(1);
      if (stipple == 0) {ellipse(x, y, sizes, sizes); stippledraw.ellipse(x, y, sizes, sizes); }  //circles
      else if (stipple == 1) {rect(x, y, sizes, sizes, 3); stippledraw.rect(x, y, sizes, sizes, 3); }  //lazy squares
      else if (stipple == 2) {rect(x, y, sizes, sizes); stippledraw.rect(x, y, sizes, sizes); }  //squares
      else if (stipple == 3) {triangle(x,y,x-sizes, y, x-(sizes/2),y-sizes); stippledraw.triangle(x,y,x-sizes, y, x-(sizes/2),y-sizes); } //triangles
      else if (stipple == 4) {arc(x, y, sizes, sizes, 0, PI, CHORD); stippledraw.arc(x, y, sizes, sizes, 0, PI, CHORD); }  //half circles up open
      else if (stipple == 5) {arc(x, y, sizes, sizes, PI / 2, 3 * PI / 2, CHORD); stippledraw.arc(x, y, sizes, sizes, PI / 2, 3 * PI / 2, CHORD); }  //half circles right open
      else if (stipple == 6) {arc(x, y, sizes, sizes, -PI, 0, CHORD); stippledraw.arc(x, y, sizes, sizes, -PI, 0, CHORD); }  //half circles down open
      else if (stipple == 7) {arc(x, y, sizes, sizes, 3 * PI / 2, PI * 2.5, CHORD); stippledraw.arc(x, y, sizes, sizes, 3 * PI / 2, PI * 2.5, CHORD); }  //half circles left open
      if (x-spacing <= 0 || y-spacing <= 0 || x+spacing >= height || y+spacing >= width)
        {if (save == 1){ saver(); }
          noLoop(); }
    }
  }
}

void mousePressed(){
   if (mouseButton == LEFT){
     println(reverse);
     reverse = 1;
     original_img.filter(INVERT);
     println("reversed " + reverse);
   }
    else if (mouseButton == CENTER){
      save = 1;
    }
    else if (mouseButton == RIGHT){
      stipple ++;
      println("change it up " + stipple);
      if (stipple > 7) {stipple = 0;}
    }
  restart ();
    loop();
}

void keyPressed() {
  if (key == 'l' || key == 'L') { infile(); }  //load a new image
  else if (key == 's' || key == 'S') { outfile(); }  //select a save file
  else if (key == 'd' || key == 'D') { disp(); }  //display image file 
  else if (key == '+') {spacing = spacing + 1; restart(); }  //change spacing of the stipple
  else if (key == '-') {spacing = spacing - 1; restart(); }
}

void saver (){
  save = 0;
  println("supersaver here");
  stippledraw.endDraw();
  start = 1;
  println("finished");
  restart();
}

void disp(){
  if (display == 1) {
        display = 0;
        println("stop showing me the image", display);
        restart();
      } else {
        display = 1;
        println("show me the image", display);
        restart();        
      }
    }

void outfile() {
  selectOutput("Select a file to write to:", "savefileSelected");
}
   
void infile() {
   selectInput("Select a file to process:", "loadfileSelected");
}

void loadfileSelected(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } else {
    println("User selected " + selection.getAbsolutePath());
    loaded = selection.getAbsolutePath();
    start = 1;
    restart();
  }
}

void savefileSelected(File selection) {
  if (selection == null) {
    println("Window was closed or the user hit cancel.");
  } else {
    println("User selected " + selection.getAbsolutePath());
    saver = selection.getAbsolutePath();
    restart();
  }
}

void restart(){
    if (start == 1) {
      println ("starting");
    original_img = loadImage(loaded);
    original_img.resize(600, 600);
    original_img.filter(GRAY);
      start =0;
    } else {
      stippledraw.background(255);
  }
    frameCount = counter = 0; 
    x = 0; y = 0;
      //if (reverse == 1){original_img.filter(INVERT); reverse = 0; } 
    stippledraw = createGraphics(600, 600, SVG, saver + ".svg"); //.svg save file name
    stippledraw.beginDraw();
    stippledraw.stroke(0);
    stippledraw.strokeWeight(1);
    stippledraw.noFill();
  if (display == 1){ //<>//
    println(display);
     image(original_img, 0, 0);}
    else {
      println(display);
      background(255);
    } 
    loop();
}
